// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "mshtmlhook.h"
#include "DlgProxy.h"
#include "mshtmlhookDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMshtmlhookDlgAutoProxy

IMPLEMENT_DYNCREATE(CMshtmlhookDlgAutoProxy, CCmdTarget)

CMshtmlhookDlgAutoProxy::CMshtmlhookDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CMshtmlhookDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CMshtmlhookDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CMshtmlhookDlgAutoProxy::~CMshtmlhookDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CMshtmlhookDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CMshtmlhookDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CMshtmlhookDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CMshtmlhookDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CMshtmlhookDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IMshtmlhook to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {2A54DB18-09AC-4E58-88C3-D6E2A762E08F}
static const IID IID_IMshtmlhook =
{ 0x2a54db18, 0x9ac, 0x4e58, { 0x88, 0xc3, 0xd6, 0xe2, 0xa7, 0x62, 0xe0, 0x8f } };

BEGIN_INTERFACE_MAP(CMshtmlhookDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CMshtmlhookDlgAutoProxy, IID_IMshtmlhook, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {212DA574-2896-4F50-A8D1-41C238FC2F8F}
IMPLEMENT_OLECREATE2(CMshtmlhookDlgAutoProxy, "Mshtmlhook.Application", 0x212da574, 0x2896, 0x4f50, 0xa8, 0xd1, 0x41, 0xc2, 0x38, 0xfc, 0x2f, 0x8f)

/////////////////////////////////////////////////////////////////////////////
// CMshtmlhookDlgAutoProxy message handlers
